Scala Compiler2.13.0 < Back


# Packages

-  package root

  The Scala compiler and reflection APIs.

  The Scala compiler and reflection APIs.

  Definition Classes
    root
-  package scala
  Definition Classes
    root
-  package tools
  Definition Classes
    scala
-  package nsc
  Definition Classes
    tools
-  package transform
  Definition Classes
    nsc
-  package patmat
  Definition Classes
    transform
- Debugging
- Interface
- Lit
- Logic
- MatchAnalysis
- MatchApproximation
- MatchCodeGen
- MatchCps
- MatchOptimization
- MatchTranslation
- MatchTreeMaking
- MatchWarnings
- PatternExpansion
- PatternMatching
- PatternMatchingStats
- ScalaLogic
- Solving
- TreeAndTypeAnalysis

t

scala.tools.nsc.transform.patmat

# TreeAndTypeAnalysis

###

#### trait TreeAndTypeAnalysis extends Debugging

Source
  MatchAnalysis.scala

Linear Supertypes
Debugging, AnyRef, Any
Known Subclasses
patmat, MatchAnalysis, MatchApproximation, MatchOptimization, PatternMatching, ScalaLogic
Type Hierarchy

Ordering

1. Alphabetic
2. By Inheritance

Inherited

1. TreeAndTypeAnalysis
2. Debugging
3. AnyRef
4. Any

Implicitly

1. by any2stringadd
2. by StringFormat
3. by Ensuring
4. by ArrowAssoc

1. Hide All
2. Show All

Visibility

1. Public
2. All

### Type Members

1.  trait CheckableTreeAndTypeAnalysis extends AnyRef

### Abstract Value Members

1.  abstract val global: Global
   Definition Classes
     Debugging

### Concrete Value Members

1.  object debug
   Definition Classes
     Debugging
2.  final def !=(arg0: Any): Boolean
   Definition Classes
     AnyRef → Any
3.  final def ##(): Int
   Definition Classes
     AnyRef → Any
4.  def +(other: String): String
   Implicit
     This member is added by an implicit conversion from TreeAndTypeAnalysis toany2stringadd[TreeAndTypeAnalysis] performed by method any2stringadd in scala.Predef.
   Definition Classes
     any2stringadd
5.  def ->[B](y: B): (TreeAndTypeAnalysis, B)
   Implicit
     This member is added by an implicit conversion from TreeAndTypeAnalysis toArrowAssoc[TreeAndTypeAnalysis] performed by method ArrowAssoc in scala.Predef.
   Definition Classes
     ArrowAssoc
   Annotations
     @inline()
6.  final def ==(arg0: Any): Boolean
   Definition Classes
     AnyRef → Any
7.  final def asInstanceOf[T0]: T0
   Definition Classes
     Any
8.  def binderTypeImpliedByPattern(pat: Global.Tree, pt: Global.Type, binder: Global.Symbol): Global.Type

   Compute the type T implied for a value `v` matched by a pattern `pat` (with expected type `pt`).

   Compute the type T implied for a value `v` matched by a pattern `pat` (with expected type `pt`).

   Usually, this is the pattern's type because pattern matching implies instance-of checks.

   However, Stable Identifier and Literal patterns are matched using `==`, which does not imply a type for the binder that binds the matched value.

   See scala/bug#1503, scala/bug#5024: don't cast binders to types we're not sure they have

9.  def clone(): AnyRef
   Attributes
     protected[java.lang]
   Definition Classes
     AnyRef
   Annotations
     @throws(classOf[java.lang.CloneNotSupportedException]) @native()
10.  def ensuring(cond: (TreeAndTypeAnalysis) => Boolean, msg: => Any): TreeAndTypeAnalysis
    Implicit
      This member is added by an implicit conversion from TreeAndTypeAnalysis toEnsuring[TreeAndTypeAnalysis] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring
11.  def ensuring(cond: (TreeAndTypeAnalysis) => Boolean): TreeAndTypeAnalysis
    Implicit
      This member is added by an implicit conversion from TreeAndTypeAnalysis toEnsuring[TreeAndTypeAnalysis] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring
12.  def ensuring(cond: Boolean, msg: => Any): TreeAndTypeAnalysis
    Implicit
      This member is added by an implicit conversion from TreeAndTypeAnalysis toEnsuring[TreeAndTypeAnalysis] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring
13.  def ensuring(cond: Boolean): TreeAndTypeAnalysis
    Implicit
      This member is added by an implicit conversion from TreeAndTypeAnalysis toEnsuring[TreeAndTypeAnalysis] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring
14.  final def eq(arg0: AnyRef): Boolean
    Definition Classes
      AnyRef
15.  def equals(arg0: AnyRef): Boolean
    Definition Classes
      AnyRef → Any
16.  def equivalentTree(a: Global.Tree, b: Global.Tree): Boolean
17.  def finalize(): Unit
    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws(classOf[java.lang.Throwable])
18.  def formatted(fmtstr: String): String
    Implicit
      This member is added by an implicit conversion from TreeAndTypeAnalysis toStringFormat[TreeAndTypeAnalysis] performed by method StringFormat in scala.Predef.
    Definition Classes
      StringFormat
    Annotations
      @inline()
19.  final def getClass(): Class[_ <: AnyRef]
    Definition Classes
      AnyRef → Any
    Annotations
      @native()
20.  def hashCode(): Int
    Definition Classes
      AnyRef → Any
    Annotations
      @native()
21.  def instanceOfTpImplies(tp: Global.Type, tpImplied: Global.Type): Boolean
22.  final def isInstanceOf[T0]: Boolean
    Definition Classes
      Any
23.  final def ne(arg0: AnyRef): Boolean
    Definition Classes
      AnyRef
24.  final def notify(): Unit
    Definition Classes
      AnyRef
    Annotations
      @native()
25.  final def notifyAll(): Unit
    Definition Classes
      AnyRef
    Annotations
      @native()
26.  final def synchronized[T0](arg0: => T0): T0
    Definition Classes
      AnyRef
27.  def toString(): String
    Definition Classes
      AnyRef → Any
28.  final def wait(): Unit
    Definition Classes
      AnyRef
    Annotations
      @throws(classOf[java.lang.InterruptedException])
29.  final def wait(arg0: Long, arg1: Int): Unit
    Definition Classes
      AnyRef
    Annotations
      @throws(classOf[java.lang.InterruptedException])
30.  final def wait(arg0: Long): Unit
    Definition Classes
      AnyRef
    Annotations
      @throws(classOf[java.lang.InterruptedException]) @native()

### Deprecated Value Members

1.  def →[B](y: B): (TreeAndTypeAnalysis, B)
   Implicit
     This member is added by an implicit conversion from TreeAndTypeAnalysis toArrowAssoc[TreeAndTypeAnalysis] performed by method ArrowAssoc in scala.Predef.
   Definition Classes
     ArrowAssoc
   Annotations
     @deprecated
   Deprecated

     (Since version 2.13.0) Use `->` instead. If you still wish to display it as one character, consider using a font with programming ligatures such as Fira Code.

### Inherited from Debugging

### Inherited from AnyRef

### Inherited from Any

### Inherited by implicit conversion any2stringadd fromTreeAndTypeAnalysis to any2stringadd[TreeAndTypeAnalysis]

### Inherited by implicit conversion StringFormat fromTreeAndTypeAnalysis to StringFormat[TreeAndTypeAnalysis]

### Inherited by implicit conversion Ensuring fromTreeAndTypeAnalysis to Ensuring[TreeAndTypeAnalysis]

### Inherited by implicit conversion ArrowAssoc fromTreeAndTypeAnalysis to ArrowAssoc[TreeAndTypeAnalysis]

### Ungrouped